SYSTEMD-ANALYZE(1)

NAME
systemd-analyze - Analyze and debug system manager

SYNOPSIS

systemd-analyze [OPTIONS...] [time]

systemd-analyze [OPTIONS...] blame

systemd-analyze [OPTIONS...] critical-chain [UNIT...]

systemd-analyze [OPTIONS...] plot [> file.svg]

systemd-analyze [OPTIONS...] dot [PATTERN...] [> file.dot]

systemd-analyze [OPTIONS...] dump

systemd-analyze [OPTIONS...] cat-config NAME|PATH...

systemd-analyze [OPTIONS...] unit-paths

systemd-analyze [OPTIONS...] log-level [LEVEL]

systemd-analyze [OPTIONS...] log-target [TARGET]

systemd-analyze [OPTIONS...] syscall-filter [SET...]

systemd-analyze [OPTIONS...] verify [FILES...]

systemd-analyze [OPTIONS...] calendar SPECS...

systemd-analyze [OPTIONS...] service-watchdogs [BOOL]

DESCRIPTION

systemd-analyze may be used to determine system boot-up performance statistics and retrieve other state and tracing information from the system and service manager, and to verify the correctness of unit files. It is also used to access special functions useful for advanced system manager debugging.

systemd-analyze time prints the time spent in the kernel before userspace has been reached, the time spent in the initial RAM disk (initrd) before normal system userspace has been reached, and the time normal system userspace took to initialize. Note that these measurements simply measure the time passed up to the point where all system services have been spawned, but not necessarily until they fully finished initialization or the disk is idle.

systemd-analyze blame prints a list of all running units, ordered by the time they took to initialize. This information may be used to optimize boot-up times. Note that the output might be misleading as the initialization of one service might be slow simply because it waits for the initialization of another service to complete. Also note: systemd-analyze blame doesn't display results for services with Type=simple, because systemd considers such services to be started immediately, hence no measurement of the initialization delays can be done.

systemd-analyze critical-chain [UNIT...] prints a tree of the time-critical chain of units (for each of the specified UNITs or for the default target otherwise). The time after the unit is active or started is printed after the "@" character. The time the unit takes to start is printed after the "+" character. Note that the output might be misleading as the initialization of one service might depend on socket activation and because of the parallel execution of units.

systemd-analyze plot prints an SVG graphic detailing which system services have been started at what time, highlighting the time they spent on initialization.

systemd-analyze dot generates textual dependency graph description in dot format for further processing with the GraphViz dot(1) tool. Use a command line like systemd-analyze dot | dot -Tsvg > systemd.svg to generate a graphical dependency tree. Unless --order or --require is passed, the generated graph will show both ordering and requirement dependencies. Optional pattern globbing style specifications (e.g. *.target) may be given at the end. A unit dependency is included in the graph if any of these patterns match either the origin or destination node.

systemd-analyze dump outputs a (usually very long) human-readable serialization of the complete server state. Its format is subject to change without notice and should not be parsed by applications.

systemd-analyze cat-config is similar to systemctl cat, but operates on config files. It will copy the contents of a config file and any drop-ins to standard output, using the usual systemd set of directories and rules for precedence. Each argument must be either an absolute path including the prefix (such as /etc/systemd/logind.conf or /usr/lib/systemd/logind.conf), or a name relative to the prefix (such as systemd/logind.conf).

Example 1. Showing logind configuration

    $ systemd-analyze cat-config systemd/logind.conf
    # /etc/systemd/logind.conf
    ...
    [Login]
    NAutoVTs=8
    ...
    # /usr/lib/systemd/logind.conf.d/20-test.conf
    ... some override from another package
    # /etc/systemd/logind.conf.d/50-override.conf
    ... some administrator override

systemd-analyze unit-paths outputs a list of all directories from which unit files, .d overrides, and .wants, .requires symlinks may be loaded. Combine with --user to retrieve the list for the user manager instance, and --global for the global configuration of user manager instances. Note that this verb prints the list that is compiled into systemd-analyze itself, and does not comunicate with the running manager. Use

    systemctl [--user] [--global] show -p UnitPath --value

to retrieve the actual list that the manager uses, with any empty directories omitted.

systemd-analyze log-level prints the current log level of the systemd daemon. If an optional argument LEVEL is provided, then the command changes the current log level of the systemd daemon to LEVEL (accepts the same values as --log-level= described in systemd(1)).

systemd-analyze log-target prints the current log target of the systemd daemon. If an optional argument TARGET is provided, then the command changes the current log target of the systemd daemon to TARGET (accepts the same values as --log-target=, described in systemd(1)).

systemd-analyze syscall-filter [SET...] will list system calls contained in the specified system call set SET, or all known sets if no sets are specified. Argument SET must include the "@" prefix.

systemd-analyze verify will load unit files and print warnings if any errors are detected. Files specified on the command line will be loaded, but also any other units referenced by them. The full unit search path is formed by combining the directories for all command line arguments, and the usual unit load paths (variable $SYSTEMD_UNIT_PATH is supported, and may be used to replace or augment the compiled in set of unit load paths; see systemd.unit(5)). All units files present in the directories containing the command line arguments will be used in preference to the other paths.

systemd-analyze calendar will parse and normalize repetitive calendar time events, and will calculate when they will elapse next. This takes the same input as the OnCalendar= setting in systemd.timer(5), following the syntax described in systemd.time(7).

systemd-analyze service-watchdogs prints the current state of service runtime watchdogs of the systemd daemon. If an optional boolean argument is provided, then globally enables or disables the service runtime watchdogs (WatchdogSec=) and emergency actions (e.g. OnFailure= or StartLimitAction=); see systemd.service(5). The hardware watchdog is not affected by this setting.

If no command is passed, systemd-analyze time is implied.

OPTIONS

The following options are understood:

--system
    Operates on the system systemd instance. This is the implied default.

--user
    Operates on the user systemd instance.

--global
    Operates on the system-wide configuration for user systemd instance.

--order, --require
    When used in conjunction with the dot command (see above), selects which dependencies are shown in the dependency graph. If --order is passed, only dependencies of type After= or Before= are shown. If --require is passed, only dependencies of type Requires=, Requisite=, Wants= and Conflicts= are shown. If neither is passed, this shows dependencies of all these types.

--from-pattern=, --to-pattern=
    When used in conjunction with the dot command (see above), this selects which relationships are shown in the dependency graph. Both options require a glob(7) pattern as an argument, which will be matched against the left-hand and the right-hand, respectively, nodes of a relationship.

    Each of these can be used more than once, in which case the unit name must match one of the values. When tests for both sides of the relation are present, a relation must pass both tests to be shown. When patterns are also specified as positional arguments, they must match at least one side of the relation. In other words, patterns specified with those two options will trim the list of edges matched by the positional arguments, if any are given, and fully determine the list of edges shown otherwise.

--fuzz=timespan
    When used in conjunction with the critical-chain command (see above), also show units, which finished timespan earlier, than the latest unit in the same level. The unit of timespan is seconds unless specified with a different unit, e.g. "50ms".

--man=no
    Do not invoke man to verify the existence of man pages listed in Documentation=.

--generators
    Invoke unit generators, see systemd.generator(7). Some generators require root privileges. Under a normal user, running with generators enabled will generally result in some warnings.

--root=PATH
    With cat-files, show config files underneath the specified root path PATH.

-H, --host=
    Execute the operation remotely. Specify a hostname, or a username and hostname separated by "@", to connect to. The hostname may optionally be suffixed by a container name, separated by ":", which connects directly to a specific container on the specified host. This will use SSH to talk to the remote machine manager instance. Container names may be enumerated with machinectl -H HOST.

-M, --machine=
    Execute operation on a local container. Specify a container name to connect to.

-h, --help
    Print a short help text and exit.

--version
    Print a short version string and exit.

--no-pager
    Do not pipe output into a pager.

EXIT STATUS

On success, 0 is returned, a non-zero failure code otherwise.

EXAMPLES FOR DOT

Example 2. Plots all dependencies of any unit whose name starts with "avahi-daemon"

    $ systemd-analyze dot 'avahi-daemon.*' | dot -Tsvg > avahi.svg
    $ eog avahi.svg

Example 3. Plots the dependencies between all known target units

    $ systemd-analyze dot --to-pattern='*.target' --from-pattern='*.target' | dot -Tsvg > targets.svg
    $ eog targets.svg

EXAMPLES FOR VERIFY

The following errors are currently detected:

    • unknown sections and directives,

    • missing dependencies which are required to start the given unit,

    • man pages listed in Documentation= which are not found in the system,

    • commands listed in ExecStart= and similar which are not found in the system or not executable.

Example 4. Misspelt directives

    $ cat ./user.slice
    [Unit]
    WhatIsThis=11
    Documentation=man:nosuchfile(1)
    Requires=different.service
    [Service]
    Description=x
    $ systemd-analyze verify ./user.slice
    [./user.slice:9] Unknown lvalue 'WhatIsThis' in section 'Unit'
    [./user.slice:13] Unknown section 'Service'. Ignoring.
    Error: org.freedesktop.systemd1.LoadFailed:
       Unit different.service failed to load:
       No such file or directory.
    Failed to create user.slice/start: Invalid argument
    user.slice: man nosuchfile(1) command failed with code 16

Example 5. Missing service units

    $ tail ./a.socket ./b.socket
    ==> ./a.socket <==
    [Socket]
    ListenStream=100
    ==> ./b.socket <==
    [Socket]
    ListenStream=100
    Accept=yes
    $ systemd-analyze verify ./a.socket ./b.socket
    Service a.service not loaded, a.socket cannot be started.
    Service b@0.service not loaded, b.socket cannot be started.

ENVIRONMENT

$SYSTEMD_PAGER
    Pager to use when --no-pager is not given; overrides $PAGER. If neither $SYSTEMD_PAGER nor $PAGER are set, a set of well-known pager implementations are tried in turn, including less(1) and more(1), until one is found. If no pager implementation is discovered no pager is invoked. Setting this environment variable to an empty string or the value "cat" is equivalent to passing --no-pager.

$SYSTEMD_LESS
    Override the options passed to less (by default "FRSXMK").

$SYSTEMD_LESSCHARSET
    Override the charset passed to less (by default "utf-8", if the invoking terminal is determined to be UTF-8 compatible).

SEE ALSO

systemd(1), systemctl(1)